# gateway to korean meteorology agency (1999/10/22)
# create by Joh, Yong-iL <tolkien@nownuri.net>
#
# Revision    : $Revision: 1.2 $
# Last Update : $Date: 2003/08/22 02:26:15 $
#

package Kma::Plugin;

use Perlbot;

use POSIX;
use HTTP::Lite;

sub get_hooks {
  return { public => \&on_public, msg => \&on_msg };
}

sub on_public {
  my $conn = shift;
  my $event = shift;
  my $args;

  $args = $event->{args}[0];
  if($args =~ /^-/) {
    get_kma($conn, $event, $event->{to}[0]);
  }
}

sub on_msg {
  my $conn = shift;
  my $event = shift;
  my $args;

  $args = $event->{args}[0];
  if($args =~ /^-/) {
    get_kma($conn, $event, $event->nick);
  }
}

sub get_kma {
  my $conn = shift;
  my $event = shift;
  my $who = shift;

  if(!defined($pid = fork)) {
    $conn->privmsg($chan, "error in  plugin...");
    return;
  }

  if($pid) {
    #parent

    $SIG{CHLD} = sub { wait; };
    return;

  } else {
    # child

    my ($city, $search, @scharr);
    ($city = $event->{args}[0]) =~ s/^-\s*//;
    $city =~ s/\s//g;
    $city = "" unless($city);
    @scharr = split(/,/, $city);
    $search = join('|', @scharr);

    my ($url, $file, $http, $stat);
    $url = "http://www.kma.go.kr/kma_syn/sfc_now.html";
    $file = "${datadir}/KMA.dat";

    $http = new HTTP::Lite;
    $stat = $http->request($url);
    if ($stat == 200) {
        open FILE, ">" . $file;
        print FILE $http->body();
        close FILE;
    }

    open FILE, $file || die "cannot open file";

    ####{{NEW: 2001-09-07 by biko
      my ($lala, @tmp);
      my $count = 0;
      while ($lala = <FILE>) {

        $lala =~ s/\s*//g;
        if($lala =~ /($search)/) {
          $city = $1;

	  $lala =~ s/^<td([^>]+)>$city<\/td>//;
	  $lala =~ s/\&([a-z]+);//g;
          undef @tmp;
          while($lala =~ /^<td([^>]+)>([^<]*)<\/td>/) {
            push(@tmp, $2);
            $lala = $';
          }

          if($#tmp >= 9) {
            # ǳ
            if($tmp[4] ne '') {
              $tmp[4] =~ s/E//g;
              $tmp[4] =~ s/W//g;
              $tmp[4] =~ s/S//g;
              $tmp[4] =~ s/N//g;
              # ǳ
              if($tmp[5] ne '') {
              $tmp[4] .= " $tmp[5] m/s";
              }
            }
            else{
              $tmp[4] = "";
            }

            my $msg = "[\x02${city}\x02] ";
	    if($tmp[0] ne '') { $msg .= "$tmp[0] / "; }
	    $msg .= "µ: $tmp[3] / ٶ: $tmp[4]";
            if($tmp[6] ne '') { $msg .= " / : $tmp[6]%"; }
	    if ($#tmp == 9) { ## 
              if($tmp[7] ne '') { $msg .= " / : $tmp[7]mm"; }
              if($tmp[8] ne '') { $msg .= " / : $tmp[8]"; }
            }
            else { ## ܿ
              if($tmp[7] ne '') { $msg .= " / : $tmp[7]mm"; }
              if($tmp[8] ne '') { $msg .= " / : $tmp[8]cm"; }
              if($tmp[9] ne '') { $msg .= " / : $tmp[9]cm"; }
            }

            $conn->privmsg($who, "$msg\n");
          }

	  if (++$count > $#scharr) {
            last;
	  }
        }
      }

    close FILE;
    $conn->{_connected} = 0;
    exit 0;
  }
}

1;
